% this script shows the dependency of average training set error (red) and test 
% set error (blue) on the training set size
%min_k is the smallest number of points to train on
%the largest size of training set is all data available

x_train = 3*rand(200,1); % fake some datapoints
x_test = 3*rand(200,1);  %
coeff_true = [5 4 3 2 1]';
y_test = generate_y(x_test, coeff_true, 5);   % generate the datapoints for 
                                              % testing and training according to the 
y_train = generate_y(x_train, coeff_true, 5); % model t = \sum w_i cos(ix) + noise
min_k = 30;
error_train = zeros(size(x_train, 1) - min_k + 1, 1);
error_test = zeros(size(x_train, 1) - min_k + 1, 1);
for k=min_k:size(x_train,1)
  x_train_used = x_train(1:k);
  y_train_used = y_train(1:k);
  F_train = generate_F(x_train_used, length(coeff_true));
  coeff = regress(F_train, y_train_used);
  error_train(k + 1 - min_k) = avg_error(x_train_used, y_train_used, coeff);
  error_test(k + 1 - min_k) = avg_error(x_test, y_test, coeff);
end;
plot(1:size(error_train,1), error_train, '-', 'LineWidth',2, 'Color', 'r');
hold on
plot(1:size(error_train,1), error_test, '-', 'LineWidth',2, 'Color', 'b');